function Overlay(parent_element, name, showOK, showCancel, showPassword, showText, titleText, inputText, bodyHTML, okFunction){

	this._name = name;
	parent_element.innerHTML = "";
	this._init(parent_element, name, showOK, showCancel, showPassword, showText, titleText, inputText, bodyHTML, okFunction);
	
}

Overlay.prototype._init = function(parent_element, name, showOK, showCancel, showPassword, showText, titleText, inputText, bodyHTML, okFunction){
	
	var _self = this;
	
	var message_container = null;
	var message_header = null;
	var message_header_button = null;
	var message_header_text = null;

	var message_body = null;
	var message_input = null;

	var message_input_text = null;
	var message_input_password = null;
	var message_input_buttons = null;
	
	/* Contains the entire message block */
	message_container = document.createElement("div");
	var style = message_container.style;
	style.display = "block";
	style.position = "relative";
	style.top = "22px";
	style.left = "32px";
	style.width = "197px";
	style.fontFamily = "Arial, Helvetica, sans-serif";
	style.fontSize = "12px";
	style.color = "#333333";
	style.border = "1px solid #454545";
	
	this._container = message_container;
	this._container.id = this._name;
	this._container.parentObject = this;
	
	/* The header on a message which has a close button and, if needed, a title message */
	message_header = document.createElement("div");
	style = message_header.style;
	style.width = "197px";
	style.height = "17px";
	style.background = "url(images/messagebar.png) no-repeat top left";
	message_container.appendChild(message_header);
	
	message_header_button = document.createElement("div");
	style = message_header_button.style;
	style.position = "absolute";
	style.left = "6px";
	style.top = "0px";
	style.margin = "0px";
	style.width = "15px";
	style.paddingTop = "0px";
	style.paddingBottom = "0px";
	style.verticalAlign = "middle";
	message_header.appendChild(message_header_button);
		
	var message_header_button_image = document.createElement("img");
	message_header_button_image.src="images/closemessage.png" 
	message_header_button_image.addEventListener("mouseup", function(event) { _self.remove(); }, true);
	message_header_button.appendChild(message_header_button_image);
	
	message_header_text = document.createElement("div");
	style = message_header_text.style;
	message_header_text.innerHTML = titleText;
	style.position = "absolute";
	style.left = "16px";
	style.top = "3px";
	style.width = "174px";
	style.fontWeight = "bold";
	style.textAlign = "center";
	style.display = "inline";
	message_header.appendChild(message_header_text);

	message_body = document.createElement("div");
	style = message_body.style;
	style.padding = "8px";
	style.width = "181px";
	style.background = "#FFFFFF";
	style.textAlign = "left";
	style.paddingBottom = "2px";
	message_body.innerHTML = bodyHTML;
	message_container.appendChild(message_body);

	message_input = document.createElement("div");
	style = message_input.style;
	style.display = "block";
	style.paddingTop = "2px";
	style.padding = "4px";
	style.width = "189px";
	style.background = "#FFFFFF";
	style.textAlign = "center";
	message_container.appendChild(message_input);
	

	if(showPassword){
		message_input_password = document.createElement("div");
		style = message_input_password.style;
		style.width = "189px";
		message_input_password.innerHTML = "<input type=\"text\" maxlength=\"64\" id=\"password-input\" value=\"\" />";
		message_input.appendChild(message_input_password);
	}

	if(showText){
		message_input_text = document.createElement("div");
		message_input_text.innerHTML = inputText;
		style = message_input_text.style;
		style.textAlign = "center";
		message_input.appendChild(message_input_text);
	}
	
	if(showOK || showCancel){
		message_input_buttons = document.createElement("div");
		style = message_input_buttons.style;
		style.display = "inline-block";
		style.verticalAlign = "bottom";
		style.textAlign = "center";
		message_input.appendChild(message_input_buttons);
	}
	
	if(showOK){
		ok_button = document.createElement("div");
		ok_button.id = "ok-button";
		style = ok_button.style;
		style.padding = "2px";
		style.display = "inline-block";
		style.verticalAlign = "bottom";	
		message_input_buttons.appendChild(ok_button);	
		
		okbutton = new AppleGlassButton( ok_button, "OK", function(){okFunction(); _self.remove();});
	}
	
	if(showCancel){
		cancel_button = document.createElement("div");
		cancel_button.id = "cancel-button";
		style = cancel_button.style;
		style.padding = "2px";
		style.display = "inline-block";
		style.verticalAlign = "bottom";
		message_input_buttons.appendChild(cancel_button);
		
		cancelbutton = new AppleGlassButton( cancel_button, "Cancel", function(){_self.remove();} );
	}
	
	
	parent_element.appendChild(message_container);
	parent_element.style.display = "block";
}

Overlay.prototype.remove = function()
{	
	var parent = this._container.parentNode;
	if(parent){
		parent.removeChild(this._container);
		parent.style.display = "none";
	}
}